import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:one_target_mobile_sdk/one_target_mobile_sdk.dart';
import 'package:one_target_mobile_sdk_example/common/constant.dart';
import 'package:one_target_mobile_sdk_example/screens/home/home_screen.dart';

import 'common/utils.dart';
import 'controller/debug_controller.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  DebugController cDebug = Get.put(DebugController());
  _setupTracking(cDebug);
  runApp(const HomeScreen());
}

void _setupTracking(DebugController debugController) {
  // Constant.setEnv(Constant.environmentDev);
  // Constant.setEnv(Constant.environmentStag);
  Constant.setEnv(Constant.environmentProd);

  G1SDK.instance.setupSDK(
    Constant.getWorkSpaceId(),
    Constant.getOneTargetAppPushID(),
    isShowLog: kDebugMode,
    isEnableIAM: true,
    onLog: (String log) {
      Utils.log("onLog $log");
      debugController.addLog(log);
    },
    env: Constant.getEnv(),
  ).then((isSetupSuccess) {
    Utils.log("_setupTracking isSetupSuccess $isSetupSuccess");
  });
}
